/**
 * Reports a diagnostic. Defined in the core compiler.
 * @beta
 */
export declare const reportDiagnostic: <C extends "no-apiVersion" | "no-route" | "invalid-name" | "general-warning" | "general-error" | "invalid-dotnet-sdk-dependency" | "no-root-client" | "unsupported-auth", M extends keyof {
    "no-apiVersion": {
        readonly default: import("@typespec/compiler").CallableMessage<["service"]>;
    };
    "no-route": {
        readonly default: import("@typespec/compiler").CallableMessage<["service"]>;
    };
    "invalid-name": {
        readonly default: import("@typespec/compiler").CallableMessage<["name"]>;
    };
    "general-warning": {
        readonly default: import("@typespec/compiler").CallableMessage<["message"]>;
    };
    "general-error": {
        readonly default: import("@typespec/compiler").CallableMessage<["message"]>;
    };
    "invalid-dotnet-sdk-dependency": {
        readonly default: import("@typespec/compiler").CallableMessage<[]>;
        readonly missing: import("@typespec/compiler").CallableMessage<["dotnetMajorVersion", "downloadUrl"]>;
        readonly invalidVersion: import("@typespec/compiler").CallableMessage<["installedVersion", "dotnetMajorVersion", "downloadUrl"]>;
    };
    "no-root-client": {
        readonly default: "Cannot generate CSharp SDK since no public root client is defined in typespec file.";
    };
    "unsupported-auth": {
        readonly default: import("@typespec/compiler").CallableMessage<["message"]>;
    };
}[C]>(program: import("@typespec/compiler").Program, diag: import("@typespec/compiler").DiagnosticReport<{
    "no-apiVersion": {
        readonly default: import("@typespec/compiler").CallableMessage<["service"]>;
    };
    "no-route": {
        readonly default: import("@typespec/compiler").CallableMessage<["service"]>;
    };
    "invalid-name": {
        readonly default: import("@typespec/compiler").CallableMessage<["name"]>;
    };
    "general-warning": {
        readonly default: import("@typespec/compiler").CallableMessage<["message"]>;
    };
    "general-error": {
        readonly default: import("@typespec/compiler").CallableMessage<["message"]>;
    };
    "invalid-dotnet-sdk-dependency": {
        readonly default: import("@typespec/compiler").CallableMessage<[]>;
        readonly missing: import("@typespec/compiler").CallableMessage<["dotnetMajorVersion", "downloadUrl"]>;
        readonly invalidVersion: import("@typespec/compiler").CallableMessage<["installedVersion", "dotnetMajorVersion", "downloadUrl"]>;
    };
    "no-root-client": {
        readonly default: "Cannot generate CSharp SDK since no public root client is defined in typespec file.";
    };
    "unsupported-auth": {
        readonly default: import("@typespec/compiler").CallableMessage<["message"]>;
    };
}, C, M>) => void;
/**
 * Creates a diagnostic. Defined in the core compiler.
 * @beta
 */
export declare const createDiagnostic: <C extends "no-apiVersion" | "no-route" | "invalid-name" | "general-warning" | "general-error" | "invalid-dotnet-sdk-dependency" | "no-root-client" | "unsupported-auth", M extends keyof {
    "no-apiVersion": {
        readonly default: import("@typespec/compiler").CallableMessage<["service"]>;
    };
    "no-route": {
        readonly default: import("@typespec/compiler").CallableMessage<["service"]>;
    };
    "invalid-name": {
        readonly default: import("@typespec/compiler").CallableMessage<["name"]>;
    };
    "general-warning": {
        readonly default: import("@typespec/compiler").CallableMessage<["message"]>;
    };
    "general-error": {
        readonly default: import("@typespec/compiler").CallableMessage<["message"]>;
    };
    "invalid-dotnet-sdk-dependency": {
        readonly default: import("@typespec/compiler").CallableMessage<[]>;
        readonly missing: import("@typespec/compiler").CallableMessage<["dotnetMajorVersion", "downloadUrl"]>;
        readonly invalidVersion: import("@typespec/compiler").CallableMessage<["installedVersion", "dotnetMajorVersion", "downloadUrl"]>;
    };
    "no-root-client": {
        readonly default: "Cannot generate CSharp SDK since no public root client is defined in typespec file.";
    };
    "unsupported-auth": {
        readonly default: import("@typespec/compiler").CallableMessage<["message"]>;
    };
}[C]>(diag: import("@typespec/compiler").DiagnosticReport<{
    "no-apiVersion": {
        readonly default: import("@typespec/compiler").CallableMessage<["service"]>;
    };
    "no-route": {
        readonly default: import("@typespec/compiler").CallableMessage<["service"]>;
    };
    "invalid-name": {
        readonly default: import("@typespec/compiler").CallableMessage<["name"]>;
    };
    "general-warning": {
        readonly default: import("@typespec/compiler").CallableMessage<["message"]>;
    };
    "general-error": {
        readonly default: import("@typespec/compiler").CallableMessage<["message"]>;
    };
    "invalid-dotnet-sdk-dependency": {
        readonly default: import("@typespec/compiler").CallableMessage<[]>;
        readonly missing: import("@typespec/compiler").CallableMessage<["dotnetMajorVersion", "downloadUrl"]>;
        readonly invalidVersion: import("@typespec/compiler").CallableMessage<["installedVersion", "dotnetMajorVersion", "downloadUrl"]>;
    };
    "no-root-client": {
        readonly default: "Cannot generate CSharp SDK since no public root client is defined in typespec file.";
    };
    "unsupported-auth": {
        readonly default: import("@typespec/compiler").CallableMessage<["message"]>;
    };
}, C, M>) => import("@typespec/compiler").Diagnostic;
/**
 * Gets a tracer. Defined in the core compiler.
 * @beta
 */
export declare const getTracer: (program: import("@typespec/compiler").Program) => import("@typespec/compiler").Tracer;
//# sourceMappingURL=lib.d.ts.map